/*
 * Index Routes
 * -------------------------------------------------------------
 * This is a sample routes file. Routes and their handlers should be
 * defined here, but no logic should occur.
 */
const index = {

    /*
     * Define the prefix applied to each of these routes.
     * For example, if prefix is '/auth':
     *      '/' becomes '/auth'
     *      '/login' becomes '/auth/login'
     */
    prefix: '/',

    /*
     * Define middleware that should be applied to all
     * routes defined in this file. Middleware should be
     * included using Flitter's global mw() function, but
     * it can also be added directly using require().
     */
    middleware: [
        // _flitter.mw('HomeLogger'),
    ],

    /*
     * Define GET routes.
     * These routes are registered as GET methods.
     * Handlers for these routes should be specified as
     * an array of functions that are applied in order.
     *
     * mw() calls apply Flitter middleware
     * controller() calls get methods in Flitter controllers
     */
    get: {
        '/': [ _flitter.controller('Home').welcome ],
    },

    /*
     * Define POST routes.
     * These routes are registered as POST methods.
     * Handlers for these routes should be specified as
     * an array of functions that are applied in order.
     *
     * mw() calls apply Flitter middleware
     * controller() calls get methods in Flitter controllers
     */
    post: {

    },
}

module.exports = index